module analy  ! ׻̥ǡѲϥ⥸塼

contains

subroutine div( nx, ny, dx, dy, u, v, val )
! 2ȯ׻롼
! 
! dx, dy  u, v ϶ִθ֤, Ǥդ2ȯ׻ǽ
!
! $\frac{\partial u}{\partial x} +\frac{\partial v}{\partial y} $ 
! 2 ʬǽ񤭴,  $(i,j)$ Ǥȯ
! $\frac{u_{i+1,j}-u_{i-1,j}}{2dx} + \frac{v_{i,j+1}-v_{i,j-1}}{2dy} $
! ȤǤ. Ѥ2ȯ׻.
! ǡ­ʤΰǤ, 1 κʬǷ׻Τ, ٤
! .
! ŪֳֳʻҤΥǡΤߤ׻ǤʤΤ, ֳ֤Υǡ
! ֳ֤ޤʤԤäƤ餳Υ롼ƤӽФɬפ.
  implicit none
  integer, intent(in) :: nx  ! ǿ 1 
  integer, intent(in) :: ny  ! ǿ 2 
  real, intent(in) :: dx  ! 1 ܤʬʻҴֳ [m]
  real, intent(in) :: dy  ! 2 ܤʬʻҴֳ [m]
  real, intent(in) :: u(nx,ny)  ! x б 2 ٥ȥʬ
  real, intent(in) :: v(nx,ny)  ! y б 2 ٥ȥʬ
  real, intent(inout) :: val(nx,ny)  ! 2ȯ
  integer :: i   ! 졼ź
  integer :: j   ! 졼ź

  do j=2,ny-1
     do i=2,nx-1
        val(i,j)=0.5*((u(i+1,j)-u(i-1,j))/dx+(v(i,j+1)-v(i,j-1))/dy)
     end do
  end do

!-- ΰü ---
!-- y ξü ---
  do i=2,nx-1
     val(i,1)=0.5*(u(i+1,1)-u(i-1,1))/dx+(v(i,2)-v(i,1))/dy
     val(i,ny)=0.5*(u(i+1,ny)-u(i-1,ny))/dx+(v(i,ny)-v(i,ny-1))/dy
  end do
!-- x ξü ---
  do j=2,ny-1
     val(1,j)=(u(2,j)-u(1,j))/dx+0.5*((v(1,j+1)-v(1,j-1))/dy)
     val(nx,j)=(u(nx,j)-u(nx-1,j))/dx+0.5*((v(nx,j+1)-v(nx,j-1))/dy)
  end do
!-- 4  ---
  val(1,1)=(u(2,1)-u(1,1))/dx+(v(1,2)-v(1,1))/dy
  val(1,ny)=(u(2,ny)-u(1,ny))/dx+(v(1,ny)-v(1,ny-1))/dy
  val(nx,1)=(u(nx,1)-u(nx-1,1))/dx+(v(nx,2)-v(nx,1))/dy
  val(nx,ny)=(u(nx,ny)-u(nx-1,ny))/dx+(v(nx,ny)-v(nx,ny-1))/dy

end subroutine div


subroutine curl( nx, ny, dx, dy, u, v, val )
! 2 ٷ׻롼
!
! dx, dy  u, v ϶ִθ֤, Ǥդ2٤׻ǽ
! nx, ny μμ㤤ɬ¤٤뤳.
! dx, dy  nx, ny ν֤ˤĤƤбطϤʤ.
!
! $\frac{\partial v}{\partial x} -\frac{\partial u}{\partial y} $ 
! 2 ʬǽ񤭴,  $(i,j)$ Ǥȯ
! $\frac{v_{i,j+1}-v_{i,j-1}}{2dx} -\frac{u_{i+1,j}-u_{i-1,j}}{2dy} $
! ȤǤ. Ѥ2ȯ׻.
! ǡ­ʤΰǤ, 1 κʬǷ׻Τ, ٤
! .
! ŪֳֳʻҤΥǡΤߤ׻ǤʤΤ, ֳ֤Υǡ
! ֳ֤ޤʤԤäƤ餳Υ롼ƤӽФɬפ.
  implicit none
  integer, intent(in) :: nx  ! ǿ 1 
  integer, intent(in) :: ny  ! ǿ 2 
  real, intent(in) :: dx  ! 1 ܤʬʻҴֳ [m]
  real, intent(in) :: dy  ! 2 ܤʬʻҴֳ [m]
  real, intent(in) :: u(nx,ny)  ! x б 2 ٥ȥʬ
  real, intent(in) :: v(nx,ny)  ! y б 2 ٥ȥʬ
  real, intent(inout) :: val(nx,ny)  ! 2
  integer :: i   ! 졼ź
  integer :: j   ! 졼ź

  do j=2,ny-1
     do i=2,nx-1
        val(i,j)=0.5*((v(i+1,j)-v(i-1,j))/dx-(u(i,j+1)-u(i,j-1))/dy)
     end do
  end do

!-- ΰü ---
!-- y ξü ---
  do i=2,nx-1
     val(i,1)=0.5*(v(i+1,1)-v(i-1,1))/dx-(u(i,2)-u(i,1))/dy
     val(i,ny)=0.5*(v(i+1,ny)-v(i-1,ny))/dx-(u(i,ny)-u(i,ny-1))/dy
  end do
!-- x ξü ---
  do j=2,ny-1
     val(1,j)=(v(2,j)-v(1,j))/dx-0.5*((u(1,j+1)-u(1,j-1))/dy)
     val(nx,j)=(v(nx,j)-v(nx-1,j))/dx-0.5*((u(nx,j+1)-u(nx,j-1))/dy)
  end do
!-- 4  ---
  val(1,1)=(v(2,1)-v(1,1))/dx-(u(1,2)-u(1,1))/dy
  val(1,ny)=(v(2,ny)-v(1,ny))/dx-(u(1,ny)-u(1,ny-1))/dy
  val(nx,1)=(v(nx,1)-v(nx-1,1))/dx-(u(nx,2)-u(nx,1))/dy
  val(nx,ny)=(v(nx,ny)-v(nx-1,ny))/dx-(u(nx,ny)-u(nx,ny-1))/dy

end subroutine curl

!-----------------------------------------
!-----------------------------------------

subroutine div_3d( nx, ny, nz, dx, dy, dz, u, v, w, val )
! 3ȯ׻롼
!
! $\frac{\partial u}{\partial x} +\frac{\partial v}{\partial y} +\frac{\partial w}{\partial z} $ 
! 2 ʬǽ񤭴,  $(i,j,k)$ Ǥȯ
! $\frac{u_{i+1,j,k}-u_{i-1,j,k}}{2dx} + \frac{v_{i,j+1,k}-v_{i,j-1,k}}{2dy} + \frac{w_{i,j,k+1}-w_{i,j,k-1}}{2dz} $
! ȤǤ. Ѥ2ȯ׻.
! ǡ­ʤΰǤ, 1 κʬǷ׻Τ, ٤
! .
! ŪֳֳʻҤΥǡΤߤ׻ǤʤΤ, ֳ֤Υǡ
! ֳ֤ޤʤԤäƤ餳Υ롼ƤӽФɬפ.
  implicit none
  integer, intent(in) :: nx  ! ǿ 1 
  integer, intent(in) :: ny  ! ǿ 2 
  integer, intent(in) :: nz  ! ǿ 3 
  real, intent(in) :: dx  ! 1 ܤʬʻҴֳ [m]
  real, intent(in) :: dy  ! 2 ܤʬʻҴֳ [m]
  real, intent(in) :: dz  ! 3 ܤʬʻҴֳ [m]
  real, intent(in) :: u(nx,ny,nz)  ! x б 3 ٥ȥʬ
  real, intent(in) :: v(nx,ny,nz)  ! y б 3 ٥ȥʬ
  real, intent(in) :: w(nx,ny,nz)  ! z б 3 ٥ȥʬ
  real, intent(inout) :: val(nx,ny,nz)  ! 3 ȯ
  integer :: i   ! 졼ź
  integer :: j   ! 졼ź
  integer :: k   ! 졼ź

!$omp parallel default(shared)
!$omp do private(i,j,k)
  do k=2,nz-1
     do j=2,ny-1
        do i=2,nx-1
           val(i,j,k)=0.5*((u(i+1,j,k)-u(i-1,j,k))/dx   &
   &                      +(v(i,j+1,k)-v(i,j-1,k))/dy   &
   &                      +(w(i,j,k+1)-w(i,j,k-1))/dz)
        end do
     end do
  end do
!$omp end do
!$omp end parallel

!-- ΰü ---
!-- ̤η׻ div 롼˷׻, η̤̤˿ľʬ
!   ȯ­碌뤳ȤǷ׻.
!-- z ˿ľ ---
  call div( nx, ny, dx, dy, u(:,:,1), v(:,:,1), val(:,:,1) )
  call div( nx, ny, dx, dy, u(:,:,nz), v(:,:,nz), val(:,:,nz) )
  do j=2,ny-1
     do i=2,nx-1
        val(i,j,1)=val(i,j,1)+(w(i,j,2)-w(i,j,1))/dz
        val(i,j,nz)=val(i,j,nz)+(w(i,j,nz)-w(i,j,nz-1))/dz
     end do
  end do

!-- y ˿ľ ---
  call div( nx, nz, dz, dx, w(:,1,:), u(:,1,:), val(:,1,:) )
  call div( nx, nz, dz, dx, w(:,ny,:), u(:,ny,:), val(:,ny,:) )
  do k=2,nz-1
     do i=2,nx-1
        val(i,1,k)=val(i,1,k)+(v(i,2,k)-v(i,1,k))/dy
        val(i,ny,k)=val(i,ny,k)+(v(i,ny,k)-v(i,ny-1,k))/dy
     end do
  end do

!-- x ˿ľ ---
  call div( ny, nz, dy, dz, v(1,:,:), w(1,:,:), val(1,:,:) )
  call div( ny, nz, dy, dz, v(nx,:,:), w(nx,:,:), val(nx,:,:) )
  do k=2,nz-1
     do j=2,ny-1
        val(1,j,k)=val(1,j,k)+(u(2,j,k)-u(1,j,k))/dx
        val(nx,j,k)=val(nx,j,k)+(u(nx,j,k)-u(nx-1,j,k))/dx
     end do
  end do

!-- ƼʿԤʶ 12 
!-- x ʿԤ 4 
  do i=2,nx-1
     val(i,1,1)=0.5*(u(i+1,1,1)-u(i-1,1,1))/dx  &
    &          +(v(i,2,1)-v(i,1,1))/dy  &
    &          +(w(i,1,2)-w(i,1,1))/dz
     val(i,ny,1)=0.5*(u(i+1,ny,1)-u(i-1,ny,1))/dx  &
    &          +(v(i,ny,1)-v(i,ny-1,1))/dy  &
    &          +(w(i,ny,2)-w(i,ny,1))/dz
     val(i,1,nz)=0.5*(u(i+1,1,nz)-u(i-1,1,nz))/dx  &
    &          +(v(i,2,nz)-v(i,1,nz))/dy  &
    &          +(w(i,1,nz)-w(i,1,nz-1))/dz
     val(i,ny,nz)=0.5*(u(i+1,ny,nz)-u(i-1,ny,nz))/dx  &
    &          +(v(i,ny,nz)-v(i,ny-1,nz))/dy  &
    &          +(w(i,ny,nz)-w(i,ny,nz-1))/dz
  end do

!-- y ʿԤ 4 
  do j=2,ny-1
     val(1,j,1)=(u(2,j,1)-u(1,j,1))/dx  &
    &          +0.5*(v(1,j+1,1)-v(1,j-1,1))/dy  &
    &          +(w(1,j,2)-w(1,j,1))/dz
     val(nx,j,1)=(u(nx,j,1)-u(nx-1,j,1))/dx  &
    &          +0.5*(v(nx,j+1,1)-v(nx,j-1,1))/dy  &
    &          +(w(nx,j,2)-w(nx,j,1))/dz
     val(1,j,nz)=(u(2,j,nz)-u(1,j,nz))/dx  &
    &          +0.5*(v(1,j+1,nz)-v(1,j-1,nz))/dy  &
    &          +(w(1,j,nz)-w(1,j,nz-1))/dz
     val(nx,j,nz)=(u(nx,j,nz)-u(nx-1,j,nz))/dx  &
    &          +0.5*(v(nx,j+1,nz)-v(nx,j-1,nz))/dy  &
    &          +(w(nx,j,nz)-w(nx,j,nz-1))/dz
  end do

!-- z ʿԤ 4 
  do k=2,nz-1
     val(1,1,k)=(u(2,1,k)-u(1,1,k))/dx  &
    &          +(v(1,2,k)-v(1,1,k))/dy  &
    &          +0.5*(w(1,1,k+1)-w(1,1,k-1))/dz
     val(nx,1,k)=(u(nx,1,k)-u(nx-1,1,k))/dx  &
    &          +(v(nx,2,k)-v(nx,1,k))/dy  &
    &          +0.5*(w(nx,1,k+1)-w(nx,1,k-1))/dz
     val(1,ny,k)=(u(2,ny,k)-u(1,ny,k))/dx  &
    &          +(v(1,ny,k)-v(1,ny-1,k))/dy  &
    &          +0.5*(w(1,ny,k+1)-w(1,ny,k-1))/dz
     val(nx,ny,k)=(u(nx,ny,k)-u(nx-1,ny,k))/dx  &
    &          +(v(nx,ny,k)-v(nx,ny-1,k))/dy  &
    &          +0.5*(w(nx,ny,k+1)-w(nx,ny,k-1))/dz
  end do

!-- 8  ---
  val(1,1,1)=(u(2,1,1)-u(1,1,1))/dx  &
  &         +(v(1,2,1)-v(1,1,1))/dy  &
  &         +(w(1,1,2)-w(1,1,1))/dz
  val(nx,1,1)=(u(nx,1,1)-u(nx-1,1,1))/dx  &
  &         +(v(nx,2,1)-v(nx,1,1))/dy  &
  &         +(w(nx,1,2)-w(nx,1,1))/dz
  val(1,ny,1)=(u(2,ny,1)-u(1,ny,1))/dx  &
  &         +(v(1,ny,1)-v(1,ny-1,1))/dy  &
  &         +(w(1,ny,2)-w(1,ny,1))/dz
  val(1,1,nz)=(u(2,1,nz)-u(1,1,nz))/dx  &
  &         +(v(1,2,nz)-v(1,1,nz))/dy  &
  &         +(w(1,1,nz)-w(1,1,nz-1))/dz
  val(nx,ny,1)=(u(nx,ny,1)-u(nx-1,ny,1))/dx  &
  &         +(v(nx,ny,1)-v(nx,ny-1,1))/dy  &
  &         +(w(nx,ny,2)-w(nx,ny,1))/dz
  val(1,ny,nz)=(u(2,ny,nz)-u(1,ny,nz))/dx  &
  &         +(v(1,ny,nz)-v(1,ny-1,nz))/dy  &
  &         +(w(1,ny,nz)-w(1,ny,nz-1))/dz
  val(nx,1,nz)=(u(nx,1,nz)-u(nx-1,1,nz))/dx  &
  &         +(v(nx,2,nz)-v(nx,1,nz))/dy  &
  &         +(w(nx,1,nz)-w(nx,1,nz-1))/dz
  val(nx,ny,nz)=(u(nx,ny,nz)-u(nx-1,ny,nz))/dx  &
  &         +(v(nx,ny,nz)-v(nx,ny-1,nz))/dy  &
  &         +(w(nx,ny,nz)-w(nx,ny,nz-1))/dz


end subroutine

!-----------------------------------------
!-----------------------------------------

subroutine rotate( nx, ny, nz, dx, dy, dz, u, v, w, zeta, eta, xi )
! 3 ٤׻.
! ν֤ϱϤ x, y, z ΥǥȺɸ,
! б٥ȥʬ u, v, w ,
! б٥٥ȥʬ zeta, eta, xi ׻.
! curl λȤޤ路.
! div_3d Ǥ div Ȥ󤷤, rotate ϳ̤˿ľʥ٥ȥȤ
! ٥٥ȥ׻Τ, ̤ȶʬΥƷ׻
! ɬפϤʤ.
! ̤˿ľʱ٥٥ȥ curl ǶޤǹθƷ׻ǽǤ.
  implicit none
  integer, intent(in) :: nx  ! ǿ 1 
  integer, intent(in) :: ny  ! ǿ 2 
  integer, intent(in) :: nz  ! ǿ 3 
  real, intent(in) :: dx  ! 1 ܤʬʻҴֳ [m]
  real, intent(in) :: dy  ! 2 ܤʬʻҴֳ [m]
  real, intent(in) :: dz  ! 3 ܤʬʻҴֳ [m]
  real, intent(in) :: u(nx,ny,nz)  ! ٥ȥ x ʬ
  real, intent(in) :: v(nx,ny,nz)  ! ٥ȥ y ʬ
  real, intent(in) :: w(nx,ny,nz)  ! ٥ȥ z ʬ
  real, intent(inout) :: zeta(nx,ny,nz)  ! ٥٥ȥ x ʬ
  real, intent(inout) :: eta(nx,ny,nz)  ! ٥٥ȥ y ʬ
  real, intent(inout) :: xi(nx,ny,nz)  ! ٥٥ȥ z ʬ
  integer :: i, j, k

!$omp parallel default(shared)
!$omp do private(i)
! x ˿ľ̾Ǥ x α٥٥ȥ 3 Ƿ׻.
  do i=1,nx
     call curl( ny, nz, dy, dz, v(i,:,:), w(i,:,:), zeta(i,:,:) )
  end do

!$omp end do
!$omp end parallel

!$omp parallel default(shared)
!$omp do private(j)
! y ˿ľ̾Ǥ y α٥٥ȥ 3 Ƿ׻.

  do j=1,ny
     call curl( nx, nz, dz, dx, w(:,j,:), u(:,j,:), eta(:,j,:) )
  end do

!$omp end do
!$omp end parallel

!$omp parallel default(shared)
!$omp do private(k)
! z ˿ľ̾Ǥ z α٥٥ȥ 3 Ƿ׻.

  do k=1,nz
     call curl( nx, ny, dx, dy, u(:,:,k), v(:,:,k), xi(:,:,k) )
  end do

!$omp end do
!$omp end parallel

end subroutine

!-----------------------------------------
!-----------------------------------------

subroutine grad_1d( nx, dx, u, val )
! 1 Υ顼ѿθۤ׻
! $\frac{\partial p}{\partial x} $ 
! 2 ʬǽ񤭴,  $(i)$ Ǥθۤ
! $\frac{p_{i+1}-p_{i-1}}{2dx} $
! ȤǤ. Ѥ 1 ۤ׻.
! ǡ­ʤΰǤ, 1 κʬǷ׻Τ, ٤
! .
! ŪֳֳʻҤΥǡΤߤ׻ǤʤΤ, ֳ֤Υǡ
! ֳ֤ޤʤԤäƤ餳Υ롼ƤӽФɬפ.
  implicit none
  integer, intent(in) :: nx  ! ǿ
  real, intent(in) :: dx  ! ʻҴֳ [m]
  real, intent(in) :: u(nx)  ! ζб 1 顼
  real, intent(inout) :: val(nx)  ! 顼ͤ x θ
  integer :: i  ! 졼ź

  do i=2,nx-1
     val(i)=0.5*(u(i+1)-u(i-1))/dx
  end do

!-- ǡΤʤξüν ---
  val(1)=(u(2)-u(1))/dx
  val(nx)=(u(nx)-u(nx-1))/dx

end subroutine grad_1d



!-- 1 顼ۤΥ롼Ѥ 2 ۤΥ٥ȥ׻ ---
subroutine grad_vec_2d( nx, ny, dx, dy, u, valx, valy )
  !-------------------------------------------------------------------
  ! $\nabla _hp =\left(\frac{\partial p}{\partial x} ,\; \frac{\partial p}{\partial y} \right) $ 
  ! 2 ʬǽ񤭴,  $(i,j)$ Ǥθۤ
  ! $\left(\frac{p_{i+1,j}-p_{i-1,j}}{2dx} ,\; \frac{p_{i,j+1}-p_{i,j-1}}{2dy} \right) $
  ! ȤǤ. Ѥ2ۤ׻.
  ! ǡ­ʤΰǤ, 1 κʬǷ׻Τ, ٤
  ! .
  ! ŪֳֳʻҤΥǡΤߤ׻ǤʤΤ, ֳ֤Υǡ
  ! ֳ֤ޤʤԤäƤ餳Υ롼ƤӽФɬפ.
  ! Ѥ 1 ۷׻롼 2 ƤӽФȤˤƤ.
  !-------------------------------------------------------------------
  implicit none
  integer, intent(in) :: nx  ! x ǿ(size ؿǼưŪ˷׻)
  integer, intent(in) :: ny  ! y ǿ(size ؿǼưŪ˷׻)
  real, intent(in) :: dx  ! x γʻֳ
  real, intent(in) :: dy  ! y γʻֳ
  real, intent(in) :: u(nx,ny)  ! ۤȤ 2 顼ʬ
  real, intent(inout) :: valx(nx,ny)  ! ׻줿 y  2 ۥ٥ȥ
  real, intent(inout) :: valy(nx,ny)  ! ׻줿 y  2 ۥ٥ȥ
  integer :: i   ! 졼ź
  integer :: j   ! 졼ź

  do i=1,ny
     call grad_1d(nx, dx, u(:,i), valx(:,i))
  end do

  do i=1,nx
     call grad_1d(ny, dy, u(i,:), valy(i,:))
  end do

end subroutine grad_vec_2d



!-- 1 顼ۤΥ롼Ѥ 3 ۤΥ٥ȥ׻ ---
subroutine grad_vec_3d( nx, ny, nz, dx, dy, dz, u, valx, valy, valz )
  !-------------------------------------------------------------------
  ! $\nabla p =\left(\frac{\partial p}{\partial x} ,\; \frac{\partial p}{\partial y} ,\; \frac{\partial p}{\partial z} \right) $ 
  ! 2 ʬǽ񤭴,  $(i,j,k)$ Ǥθۤ
  ! $\left(\frac{p_{i+1,j,k}-p_{i-1,j,k}}{2dx} ,\; \frac{p_{i,j+1,k}-p_{i,j-1,k}}{2dy} ,\; \frac{p_{i,j,k+1}-p_{i,j,k-1}}{2dz} \right) $
  ! ȤǤ. Ѥ 3 ۤ׻.
  ! ǡ­ʤΰǤ, 1 κʬǷ׻Τ, ٤
  ! .
  ! ŪֳֳʻҤΥǡΤߤ׻ǤʤΤ, ֳ֤Υǡ
  ! ֳ֤ޤʤԤäƤ餳Υ롼ƤӽФɬפ.
  ! Ѥ 1 ۷׻롼 3 ƤӽФȤˤƤ.
  !-------------------------------------------------------------------
  implicit none
  integer, intent(in) :: nx  ! x ǿ(size ؿǼưŪ˷׻)
  integer, intent(in) :: ny  ! y ǿ(size ؿǼưŪ˷׻)
  integer, intent(in) :: nz  ! z ǿ(size ؿǼưŪ˷׻)
  real, intent(in) :: dx  ! x γʻֳ
  real, intent(in) :: dy  ! y γʻֳ
  real, intent(in) :: dz  ! z γʻֳ
  real, intent(in) :: u(nx,ny,nz)  ! ۤȤ 3 顼ʬ
  real, intent(inout) :: valx(nx,ny,nz)  ! ׻줿 x  3 ۥ٥ȥ
  real, intent(inout) :: valy(nx,ny,nz)  ! ׻줿 y  3 ۥ٥ȥ
  real, intent(inout) :: valz(nx,ny,nz)  ! ׻줿 z  3 ۥ٥ȥ
  integer :: i   ! 졼ź
  integer :: j   ! 졼ź

  do i=1,nz
     do j=1,ny
        call grad_1d(nx, dx, u(:,j,i), valx(:,j,i))
     end do
  end do

  do i=1,nz
     do j=1,nx
        call grad_1d(ny, dy, u(j,:,i), valy(j,:,i))
     end do
  end do

  do i=1,ny
     do j=1,nx
        call grad_1d(nz, dz, u(j,i,:), valz(j,i,:))
     end do
  end do

end subroutine grad_vec_3d

subroutine abst(x,y,z,dis)  ! 3 ٥ȥͤ׻롼
  ! Ĵ뤳Ȥˤ, 2 Ǥη׻ǽ.
  implicit none
  real, intent(in) :: x(:,:,:)  ! x Υ٥ȥʬ
  real, intent(in) :: y(size(x,1),size(x,2),size(x,3))  ! y Υ٥ȥʬ
  real, intent(in) :: z(size(x,1),size(x,2),size(x,3))  ! z Υ٥ȥʬ
  real, intent(inout) :: dis(size(x,1),size(x,2),size(x,3))  ! Ǥͥ٥ȥ
  integer :: i, j, k, nx, ny, nz

  nx=size(x,1)
  ny=size(x,2)
  nz=size(x,3)

!$omp parallel do shared(dis,x,y,z) private(i,j,k)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           dis(i,j,k)=sqrt(x(i,j,k)**2+y(i,j,k)**2+z(i,j,k)**2)
        end do
     end do
  end do
!$omp end parallel do

end subroutine abst


subroutine radius(xp,yp,zp,x,y,z,rad)
  ! ֤εΥ׻롼
  ! Ĵ뤳Ȥˤ, 2 Ǥη׻ǽ.
  implicit none
  real, intent(in) :: xp  ! 濴ֺɸ x ʬ
  real, intent(in) :: yp  ! 濴ֺɸ y ʬ
  real, intent(in) :: zp  ! 濴ֺɸ z ʬ
  real, intent(in) :: x(:)  ! x ΰֺɸ
  real, intent(in) :: y(:)  ! y ΰֺɸ
  real, intent(in) :: z(:)  ! z ΰֺɸ
  real, intent(inout) :: rad(size(x),size(y),size(z))  ! Υ
  integer :: i, j, k, nx, ny, nz

  nx=size(x)
  ny=size(y)
  nz=size(z)

!$omp parallel do shared(rad,x,y,z,xp,yp,zp) private(i,j,k)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           rad(i,j,k)=sqrt((x(i)-xp)**2+(y(j)-yp)**2+(z(k)-zp)**2)
        end do
     end do
  end do
!$omp end parallel do


end subroutine radius


subroutine Rangular_moment(xp,yp,x,y,u,v,mome)
! Ǥդޤгѱư̤׻롼
!
!  3 ٥ȥǷ׻뤬, ݳؤǤ 3 ̤Ϥޤפʤ
! ǤȤȽǤ, žޤγѱưʬΤߤ
! ׻뤳ȤˤƤ.
!
! Ū濴濴˱ľޤγѱư̤׻뤳ȤŪȤ.
!
! $$M=rv,\quad r=濴εΥ, \quad v=®Ʊ̳ʬ$$
!
! ֤®˰٤ѴͿ, Ǥμžޤγѱư̤
! ׻뤳Ȥǽ.
! ٥ȥγѷ׻롼 vec_prod Ѥ뤳ȤǶ˺ɸǤ׻ǽ.
  implicit none
  real, intent(in) :: x(:)  ! x ΰֺɸ
  real, intent(in) :: y(:)  ! y ΰֺɸ
  real, intent(in) :: xp  ! ž x ֺɸ
  real, intent(in) :: yp  ! ž y ֺɸ
  real, intent(in) :: u(size(x),size(y))  !  i,j Ǥ® 1 ʬ
  real, intent(in) :: v(size(x),size(y))  !  i,j Ǥ® 1 ʬ
  real, intent(inout) :: mome(size(x),size(y))  ! žޤгѱư
  real :: xxp(size(x),size(y),1)  ! x,y,xp,yp ׻濴ΰ֥٥ȥ x ʬ
  real :: yyp(size(x),size(y),1)  ! x,y,xp,yp ׻濴ΰ֥٥ȥ y ʬ
  integer :: i, j, nx, ny
  real :: tmp(size(x),size(y),1)

  nx=size(x)
  ny=size(y)

!$omp parallel do shared(xxp,yyp,x,y,xp,yp) private(i,j)
  do j=1,ny
     do i=1,nx
        xxp(i,j,1)=x(i)-xp
        yyp(i,j,1)=y(j)-yp
     end do
  end do
!$omp end parallel do

  tmp=0.0
  call vec_prod(xxp,yyp,tmp,u,v,tmp,tmp,tmp,mome)

end subroutine Rangular_moment


subroutine Aangular_moment(xp,yp,x,y,u,v,f,mome)
! Ǥդޤгѱư̤׻롼
!
! Ū濴濴˱ľޤγѱư̤׻뤳ȤŪȤ.
!
! $$M=rv+\dfrac{fr^2}{2} ,\quad r=濴εΥ, \quad v=®Ʊ̳ʬ$$
!
! ֤®˰٤ѴͿ, Ǥμžޤγѱư̤
! ׻뤳Ȥǽ.
!
! ٥ȥγѷ׻롼 vec_prod Ѥ뤳ȤǶ˺ɸǤ׻ǽ.
  implicit none
  real, intent(in) :: x(:)  ! x ΰֺɸ
  real, intent(in) :: y(:)  ! y ΰֺɸ
  real, intent(in) :: xp  ! ž x ֺɸ
  real, intent(in) :: yp  ! ž y ֺɸ
  real, intent(in) :: u(size(x),size(y))  !  i,j Ǥ® 1 ʬ
  real, intent(in) :: v(size(x),size(y))  !  i,j Ǥ® 1 ʬ
  real, intent(in) :: f(size(x),size(y))  !  i,j ǤΥꥪѥ᡼
  real, intent(inout) :: mome(size(x),size(y))  ! žޤгѱư
  real :: xxp(size(x),size(y),1)  ! x,y,xp,yp ׻濴ΰ֥٥ȥ x ʬ
  real :: yyp(size(x),size(y),1)  ! x,y,xp,yp ׻濴ΰ֥٥ȥ y ʬ
  integer :: i, j, nx, ny
  real :: tmp(size(x),size(y),1), rp(size(x),size(y)), tmp1(1)

  nx=size(x)
  ny=size(y)

!$omp parallel do shared(xxp,yyp,x,y,xp,yp) private(i,j)
  do j=1,ny
     do i=1,nx
        xxp(i,j,1)=x(i)-xp
        yyp(i,j,1)=y(j)-yp
     end do
  end do
!$omp end parallel do

  tmp=0.0
  call vec_prod(xxp,yyp,tmp,u,v,tmp,tmp,tmp,mome)
  call radius(xp,yp,0.0,x,y,tmp1,rp)

!$omp parallel do shared(mome,f,rp) private(i,j)
  do j=1,ny
     do i=1,nx
        mome(i,j)=mome(i,j)+0.5*f(i,j)*rp(i,j)**2
     end do
  end do
!$omp end parallel do

end subroutine Aangular_moment

subroutine dot_prod(x,y,z,u,v,w,dot)
  ! 2٥ȥѷ׻롼
  ! פ, 2 ǤѤ׻뤳Ȥǽ
  implicit none
  real, intent(in) :: x(:,:,:)  ! x Υ٥ȥʬ
  real, intent(in) :: y(size(x,1),size(x,2),size(x,3))  ! y Υ٥ȥʬ
  real, intent(in) :: z(size(x,1),size(x,2),size(x,3))  ! z Υ٥ȥʬ
  real, intent(in) :: u(size(x,1),size(x,2),size(x,3))  ! x Υ٥ȥʬ
  real, intent(in) :: v(size(x,1),size(x,2),size(x,3))  ! y Υ٥ȥʬ
  real, intent(in) :: w(size(x,1),size(x,2),size(x,3))  ! z Υ٥ȥʬ
  real, intent(inout) :: dot(size(x,1),size(x,2),size(x,3))  ! 
  integer :: i, j, k, nx, ny, nz

  nx=size(x,1)
  ny=size(x,2)
  nz=size(x,3)

!$omp parallel do shared(dot,x,y,z,u,v,w) private(i,j,k)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           dot(i,j,k)=x(i,j,k)*u(i,j,k)+y(i,j,k)*v(i,j,k)+z(i,j,k)*w(i,j,k)
        end do
     end do
  end do
!$omp end parallel do

end subroutine dot_prod


subroutine vec_prod(x,y,z,u,v,w,vecx,vecy,vecz)
  ! 2٥ȥγѷ׻롼
  ! ǿפ뤳Ȥ 2 Ѥ׻ǽ
  implicit none
  real, intent(in) :: x(:,:,:)  ! x Υ٥ȥʬ
  real, intent(in) :: y(size(x,1),size(x,2),size(x,3))  ! y Υ٥ȥʬ
  real, intent(in) :: z(size(x,1),size(x,2),size(x,3))  ! z Υ٥ȥʬ
  real, intent(in) :: u(size(x,1),size(x,2),size(x,3))  ! x Υ٥ȥʬ
  real, intent(in) :: v(size(x,1),size(x,2),size(x,3))  ! y Υ٥ȥʬ
  real, intent(in) :: w(size(x,1),size(x,2),size(x,3))  ! z Υ٥ȥʬ
  real, intent(inout) :: vecx(size(x,1),size(x,2),size(x,3))  ! Ѥ x ʬ
  real, intent(inout) :: vecy(size(x,1),size(x,2),size(x,3))  ! Ѥ y ʬ
  real, intent(inout) :: vecz(size(x,1),size(x,2),size(x,3))  ! Ѥ z ʬ
  integer :: i, j, k, nx, ny, nz

  nx=size(x,1)
  ny=size(x,2)
  nz=size(x,3)

!$omp parallel do shared(vecx,vecy,vecz,x,y,z,u,v,w) private(i,j,k)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           vecx(i,j,k)=y(i,j,k)*w(i,j,k)-z(i,j,k)*v(i,j,k)
           vecy(i,j,k)=z(i,j,k)*u(i,j,k)-x(i,j,k)*w(i,j,k)
           vecz(i,j,k)=x(i,j,k)*v(i,j,k)-y(i,j,k)*u(i,j,k)
        end do
     end do
  end do
!$omp end parallel do

end subroutine vec_prod


end module analy
